#include <bits/stdc++.h>

using namespace std;
int ans[300001][3];
int a[300001];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n; cin >> n;
    int bot = 0;
    int prev = -1;
    for(int i=0;i<n;i++){
        cin >> a[i];
        if(a[i]<prev){
            bot = i;

        }
        prev=a[i];
        ans[i][0]=bot;// no jump
        ans[i][1]=ans[i][0];
        if(bot+1<i)ans[i][1]=min(ans[bot+1][1],ans[i][1]);//nadoknadi jump
        ans[i][1]=min(ans[i][1],ans[bot][1]);
        if(i>1 && a[i-2]<=a[i])ans[i][1]=min(ans[i-2][0],ans[i][1]);//jump
        ans[i][2]=INT_MAX;
        if(i)ans[i][2]=ans[i-1][0];
        ans[i][2]=min({ans[i][0],ans[i][1],ans[i][2]});
    }
    int q; cin >> q;
    for(int i=0;i<q;i++){
        int l,r; cin >> l >> r;
        l--;r--;
        if(l<ans[r][2])cout << "NE\n";
        else cout <<"DA\n";
    }
    return 0;
}